package itemhandler;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;


/** Class containing a single method that displays a table of item information using java swing
 * JTable, JScrollPane.
 *
 */
public class ItemTable
{

    /** Displays item details in a table using swing.
     *
     * @param itemMap HashMap containing multiple items that are to be added to the table.

     */
    public void displayItemTable(Map<String, Item> itemMap)
    {
        JFrame javaFrame = new JFrame();
        javaFrame.pack();
        JTable javaTable = new JTable(itemMapToMultiStringArray(itemMap), new Item()
            .getItemInformationMapped().keySet().toArray(String[]::new));
        javaTable.setAutoCreateRowSorter(true);
        javaTable.setBounds(50, 40, 400, 280);
        JScrollPane javaScroll = new JScrollPane(javaTable);
        javaFrame.add(javaScroll);
        javaFrame.setSize(1500, 500);
        javaFrame.setVisible(true);
    }

    private String[][] itemMapToMultiStringArray(Map<String, Item> itemMap)
    {
        Collection<String> returnString;

        List<Item> itemList = itemMap.values().stream().toList();
        ArrayList<String[]> listOfListsOfItemParameters = new ArrayList<>();
        for (Item item : itemList)
        {
            returnString = item.getItemInformationMapped().values();
            listOfListsOfItemParameters.add(returnString.toArray(String[]::new));
        }
        String[][] listOfStringLists2 = new String[listOfListsOfItemParameters.size()][];
        for (int index = 0; index < listOfListsOfItemParameters.size(); index++)
        {
            listOfStringLists2[index] = listOfListsOfItemParameters.get(index);
        }
        return listOfStringLists2;
    }
}
