package utility;

import staticconstants.Category;
import staticconstants.ValidColors;

/**Has methods that returns isValid as false with empty or null string and if a number is negative.
 *
 */
public class Parameter
{
    private static boolean isValid;

    private Parameter()
    {

    }

    /** Checks if string is empty or null, and returns false for empty or null, true otherwise.
     *
     * @param stringToCheck string to be checked
     * @return validString
     */
    public static boolean checkValid(String stringToCheck)
    {
        isValid = stringToCheck != null && !stringToCheck.equals("");
        return isValid;
    }

    /** Checks if int is negative, returns false when negative and
     * true when positive or zero.
     *
     * @param intToCheckNegative int to be checked
     * @return validString
     */
    public static boolean checkValid(int intToCheckNegative)
    {
        return intToCheckNegative > 0;
    }
    /** Checks if double is negative, returns false when negative and
     * true when positive.
     *
     * @param doubleToCheckNegative int to be checked
     * @return validString
     */

    public static boolean checkValid(double doubleToCheckNegative)
    {
        return doubleToCheckNegative > 0;
    }

    /** Checks if color typed is among the valid colors.
     *
     * @param colorToBeChecked The color that is to be checked
     * @return isValid false if
     */
    public static boolean checkValidColor(String colorToBeChecked)
    {
        isValid = false;
        int i = 0;
        if (colorToBeChecked != null && !colorToBeChecked.equals(""))
        {
            while (i < ValidColors.values().length && !isValid)
            {
                ValidColors[] validColors = ValidColors.values();
                if (colorToBeChecked.equalsIgnoreCase(String.valueOf(validColors[i])))
                {
                    isValid = true;
                }
                i++;

            }
        }

        return isValid;
    }

    /**
     * Uses Category enum values to return true if number is matching one of the
     * category numbers listed.

     * @param intToCheckValid number to be checked weather or not is a valid category.
     * @return boolean of weather the category is invalid
     */
    public static boolean checkValidCategory(int intToCheckValid)
    {
        return !(Category.getCategoryFromNumber(intToCheckValid)).equals("invalid");
    }

}
